#! /bin/sh
#========================================================================
# fmtdate formats a date
# usage fmtdate YYYYMMDD format-string
# or echo YYYYMMDD | fmtdate format-string
# assumes that if only one argument arrives, that it is the format
# the date is being piped in
#
# Author: Mo Budlong <mo.budlong@sunworld.com>
#
# Source: SunWorld Online UNIX 101 columns:
#	http://www.sunworld.com/sunworldonline/swol-11-1998/swol-11-unix101.html
#	http://www.sunworld.com/swol-12-1998/swol-12-unix101.html?1201a
#	http://www.sunworld.com/swol-01-1999/swol-01-unix101.html?0111a
#
# [13-Jan-1999]
#========================================================================

# create a temporary version of argument 2 that replaces spaces
# with x
tmpfmt=`echo $2 | tr " " x`

# test if argument 1 is empty
if [ X$1 = X ]
then
	read ymd fmt
# test if argument 2 is empty
elif [ X$tmpfmt = X ]
then
        fmt=$1
        read ymd
else
        ymd=$1
        fmt=$2
fi

# cut the 8-digit date into pieces for a 4-digit year
# a 2-digit year, a 2-digit month and a 2-digit day
yyyy=`echo $ymd | cut -c1-4`
yy=`echo $ymd | cut -c3-4`
mm=`echo $ymd | cut -c5-6`
dd=`echo $ymd | cut -c7-8`

# Create numeric versions of day and month that will suppress
# the leading zeroes
m=`expr $mm \* 1`
d=`expr $dd \* 1`

# echo the month through a sed script that will assign a full month
# name to the variable $month for the 2-digit month
month=`echo $mm | sed -e "
s/01/January/
s/02/February/
s/03/March/
s/04/April/
s/05/May/
s/06/June/
s/07/July/
s/08/August/
s/09/September/
s/10/October/
s/11/November/
s/12/December/"`

# Create a three-character abbreviation of the month by cutting the
# first three characters out on $month

mon=`echo $month | cut -c1-3`

# Use tr to create uppercase versions of $mon and $month

MON=`echo $mon | tr [a-z] [A-Z]`
MONTH=`echo $month | tr [a-z] [A-Z]`

# echo the format string through a sed script that searches for
# the key values %yyyy, %yy, %mm, %m, %dd, %d, %mon, and %month and replaces
# them with appropriate values.
echo $fmt | sed -e "
s/%yyyy/$yyyy/g
s/%month/$month/g
s/%mon/$mon/g
s/%MONTH/$MONTH/g
s/%MON/$MON/g
s/%yy/$yy/g
s/%mm/$mm/g
s/%m/$m/g
s/%dd/$dd/g
s/%d/$d/g"
